Index: src/isdn/Q921.c
===================================================================
--- src/isdn/Q921.c	(revision 495)
+++ src/isdn/Q921.c	(working copy)
@@ -350,29 +1286,105 @@
 *****************************************************************************/
 int Q921SendSABME(L2TRUNK trunk, int Sapi, int cr, int Tei, int pf)
 {
-    L2UCHAR mes[400];
-
-    mes[trunk->Q921HeaderSpace+0] = (L2UCHAR)((Sapi&0xfc) | ((cr<<1)&0x02));
-    mes[trunk->Q921HeaderSpace+1] = (L2UCHAR)((Tei<<1) | 0x01);
-    mes[trunk->Q921HeaderSpace+2] = (L2UCHAR)(0x6f | ((pf<<4)&0x10));
+	L2UCHAR mes[25];
 
-    return Q921Tx21Proc(trunk, mes, trunk->Q921HeaderSpace+3);
+	return Q921SendU(trunk, Sapi, cr, Tei, pf, 0x0f, mes, trunk->Q921HeaderSpace+3);
 }
 
+
+/**
+ * Q921Start
+ * \brief	Start trunk
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \return	> 0 on success; <= 0 on error
+ */
 int Q921Start(L2TRUNK trunk)
 {
-	return Q921SendSABME(trunk, 
-					trunk->sapi, 
-					trunk->NetUser == Q921_TE ? 0 : 1,
-					trunk->tei, 
+	if(trunk->initialized != INITIALIZED_MAGIC)
+		return 0;
+
+	if(Q921_IS_PTMP_TE(trunk)) {
+		trunk->state = Q921_STATE_TEI_UNASSIGNED;
+		trunk->tei   = 0;
+	} else
+		trunk->state = Q921_STATE_TEI_ASSIGNED;
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "Starting trunk %p (sapi: %d, tei: %d, mode: %s %s)\n",
+				 trunk,
+				 trunk->sapi,
+				 trunk->tei,
+				 Q921_IS_PTMP(trunk) ? "PTMP" : "PTP",
+				 Q921_IS_TE(trunk) ? "TE" : "NT");
+
+	if(Q921_IS_PTP(trunk)) {
+		Q921Log(trunk, Q921_LOG_DEBUG, "Sending SABME\n");
+
+		return Q921SendSABME(trunk, 
+					trunk->sapi, 
+					Q921_COMMAND(trunk),
+					trunk->tei, 
 					1);
+
+	} else if(Q921_IS_PTMP_NT(trunk)) {
+
+		Q921Log(trunk, Q921_LOG_DEBUG, "Revoking all TEIs\n");
+
+		return Q921TeiSendRemoveRequest(trunk, Q921_TEI_BCAST);	/* Revoke all TEIs in use */
+	} else {
+
+		Q921Log(trunk, Q921_LOG_DEBUG, "Requesting TEI\n");
+
+		return Q921TeiSendAssignRequest(trunk);
+	}
 }
 
+
+/**
+ * Q921Stop
+ * \brief	Stop trunk
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \return	> 0 on success; <= 0 on error
+ *
+ * \author	Stefan Knoblich
+ */
+int Q921Stop(L2TRUNK trunk)
+{
+	if(!trunk)
+		return -1;
+
+	if(Q921_IS_STOPPED(trunk))
+		return 0;
+
+	/* Flush queues, TODO: per-tei I/UI queues?  */
+	MFIFOClear(trunk->UIFrameQueue);
+	MFIFOClear(trunk->IFrameQueue);
+	MFIFOClear(trunk->HDLCInQueue);
+
+	/* Release TEI */
+	if(Q921_IS_PTMP_TE(trunk)) {
+		/* send verify request */
+		Q921TeiSendVerifyRequest(trunk);
+
+		/* drop TEI => not answering NT's check request anymore */
+		trunk->tei = 0;
+	}
+
+	/* Stop timers */
+	Q921T200TimerStop(trunk, trunk->tei);
+	Q921T203TimerStop(trunk, trunk->tei);
+	Q921T201TimerStop(trunk, trunk->tei);
+	Q921T202TimerStop(trunk);
+
+	/* Change state (no action) */
+	return Q921ChangeState(trunk, Q921_STATE_STOPPED);
+}
+
+
 /*****************************************************************************
 
   Function:     Q921SendDM
 
-  Description:  Comose and Send DM (Disconnected Mode)
+  Description:  Compose and Send DM (Disconnected Mode)
 
   Parameters:   trunk       trunk #
                 Sapi        Sapi
@@ -385,13 +1397,9 @@
 *****************************************************************************/
 int Q921SendDM(L2TRUNK trunk, int Sapi, int cr, int Tei, int pf)
 {
-    L2UCHAR mes[400];
-
-    mes[trunk->Q921HeaderSpace+0] = (L2UCHAR)((Sapi&0xfc) | ((cr<<1)&0x02));
-    mes[trunk->Q921HeaderSpace+1] = (L2UCHAR)((Tei<<1) | 0x01);
-    mes[trunk->Q921HeaderSpace+2] = (L2UCHAR)(0x0f | ((pf<<4)&0x10));
+	L2UCHAR mes[25];
 
-    return Q921Tx21Proc(trunk, mes, trunk->Q921HeaderSpace+3);
+	return Q921SendU(trunk, Sapi, cr, Tei, pf, 0x03, mes, trunk->Q921HeaderSpace+3);
 }
 
 /*****************************************************************************
@@ -411,13 +1419,9 @@
 *****************************************************************************/
 int Q921SendDISC(L2TRUNK trunk, int Sapi, int cr, int Tei, int pf)
 {
-    L2UCHAR mes[400];
+	L2UCHAR mes[25];
 
-    mes[trunk->Q921HeaderSpace+0] = (L2UCHAR)((Sapi&0xfc) | ((cr<<1)&0x02));
-    mes[trunk->Q921HeaderSpace+1] = (L2UCHAR)((Tei<<1) | 0x01);
-    mes[trunk->Q921HeaderSpace+2] = (L2UCHAR)(0x43 | ((pf<<4)&0x10));
-
-    return Q921Tx21Proc(trunk, mes, trunk->Q921HeaderSpace+3);
+	return Q921SendU(trunk, Sapi, cr, Tei, pf, 0x08, mes, trunk->Q921HeaderSpace+3);
 }
 
 /*****************************************************************************
@@ -437,28 +1441,994 @@
 *****************************************************************************/
 int Q921SendUA(L2TRUNK trunk, int Sapi, int cr, int Tei, int pf)
 {
-    L2UCHAR mes[400];
+	L2UCHAR mes[25];
 
-    mes[trunk->Q921HeaderSpace+0] = (L2UCHAR)((Sapi&0xfc) | ((cr<<1)&0x02));
-    mes[trunk->Q921HeaderSpace+1] = (L2UCHAR)((Tei<<1) | 0x01);
-    mes[trunk->Q921HeaderSpace+2] = (L2UCHAR)(0x63 | ((pf<<4)&0x10));
+	return Q921SendU(trunk, Sapi, cr, Tei, pf, 0x0c, mes, trunk->Q921HeaderSpace+3);
+}
 
-    return Q921Tx21Proc(trunk, mes, trunk->Q921HeaderSpace+3);
+int Q921SendUN(L2TRUNK trunk, int Sapi, int cr, int Tei, int pf, L2UCHAR *mes, L2INT size)
+{
+	return Q921SendU(trunk, Sapi, cr, Tei, pf, 0x00, mes, size+trunk->Q921HeaderSpace+3);
 }
 
+
+/**
+ * Q921ProcSABME
+ * \brief	Handle incoming SABME
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	mes	pointer to message buffer
+ * \param[in]	size	size of message
+ * \return	> 0 on success, <= 0 on error
+ */
 int Q921ProcSABME(L2TRUNK trunk, L2UCHAR *mes, L2INT size)
 {
-	/* TODO:  Do we need these paramaters? */
-	(void)mes;
-	(void)size;
-
-    trunk->vr=0;
-    trunk->vs=0;
-	trunk->va=0;
+	L2UCHAR pf = (mes[2] & 0x10) >> 4;				/* poll / final flag */
+	L2UCHAR tei = (mes[1] & 0xfe) >> 1;
+	L2INT   idx = tei;
+
+	if(!Q921_IS_PTMP_NT(trunk))
+		idx = 0;
+
+	switch(trunk->state) {
+	case Q921_STATE_TEI_ASSIGNED:
+		/* send UA */
+		Q921SendUA(trunk,
+				trunk->sapi,
+				Q921_RESPONSE(trunk),	/* or command? */
+				tei, pf);
+
+		/* clear counters */
+		trunk->vr[idx]=0;
+		trunk->vs[idx]=0;
+		trunk->va[idx]=0;
+
+		/* TODO: send DL-Establish indication to Q.931 */
+		Q921Tx23Proc(trunk, Q921_DL_ESTABLISH, NULL, 0);
+
+		/* start T203 */
+		Q921T203TimerStart(trunk, tei);
+
+		/* change state (no action) */
+		Q921ChangeState(trunk, Q921_STATE_MULTIPLE_FRAME_ESTABLISHED);
+		break;
+
+	case Q921_STATE_AWAITING_ESTABLISHMENT:
+		/* send UA */
+		Q921SendUA(trunk,
+				trunk->sapi,
+				Q921_RESPONSE(trunk),
+				tei, pf);
+
+		/* no state change */
+		break;
+
+	case Q921_STATE_AWAITING_RELEASE:
+		/* send DM */
+		Q921SendDM(trunk,
+				trunk->sapi,
+				Q921_RESPONSE(trunk),
+				tei, pf);
+
+		/* no state change */
+		break;
+
+	case Q921_STATE_MULTIPLE_FRAME_ESTABLISHED:
+	case Q921_STATE_TIMER_RECOVERY:
+		/* send UA */
+		Q921SendUA(trunk,
+				trunk->sapi,
+				Q921_RESPONSE(trunk),
+				tei, pf);
+
+		/* clear exception conditions */
+		Q921ResetExceptionConditions(trunk, tei);
+
+		/* send MDL-Error indication */
+
+		/* V(S) == V(A) ? */
+		if(trunk->vs[idx] != trunk->va[idx]) {
+			/* clear I queue */
+			MFIFOClear(trunk->IFrameQueue);
+
+			/* DL-Establish indication */
+			Q921Tx23Proc(trunk, Q921_DL_ESTABLISH, NULL, 0);
+		}
+
+		/* clear counters */
+		trunk->vr[idx]=0;
+		trunk->vs[idx]=0;
+		trunk->va[idx]=0;
+
+		/* Stop T200, start T203 */
+		Q921T200TimerStop(trunk, tei);
+		Q921T203TimerStart(trunk, tei);
+
+		/* state change only if in TIMER_RECOVERY state */
+		if(trunk->state == Q921_STATE_TIMER_RECOVERY)
+			Q921ChangeState(trunk, Q921_STATE_MULTIPLE_FRAME_ESTABLISHED);
+		break;
+
+	default:
+		break;
+	}
+
+	return 1;
+}
+
+
+/**
+ * Q921ProcDM
+ * \brief	Handle incoming DM
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	mes	pointer to message buffer
+ * \param[in]	size	size of message
+ * \return	> 0 on success, <= 0 on error
+ */
+int Q921ProcDM(L2TRUNK trunk, L2UCHAR *mes, L2INT size)
+{
+	L2UCHAR pf = (mes[2] & 0x10) >> 4;				/* poll / final flag */
+	L2UCHAR tei = (mes[1] & 0xfe) >> 1;
+
+	switch(trunk->state) {
+	case Q921_STATE_TEI_ASSIGNED:
+		if(!pf) {
+			/* to next state (no action) */
+			Q921ChangeState(trunk, Q921_STATE_AWAITING_ESTABLISHMENT);
+		}
+		break;
+
+	case Q921_STATE_AWAITING_ESTABLISHMENT:
+	case Q921_STATE_AWAITING_RELEASE:
+		if(pf) {
+			if(trunk->state == Q921_STATE_AWAITING_ESTABLISHMENT) {
+				/* Discard I queue */
+				MFIFOClear(trunk->IFrameQueue);
+			}
+
+			/* Send DL-Release indication to Q.931 */
+			Q921Tx23Proc(trunk, Q921_DL_RELEASE, NULL, 0);
+
+			/* Stop T200 */
+			Q921T200TimerStop(trunk, tei);
+
+			/* Change state (no action) */
+			Q921ChangeState(trunk, Q921_STATE_TEI_ASSIGNED);
+		}
+		break;
+
+	case Q921_STATE_MULTIPLE_FRAME_ESTABLISHED:
+		if(pf) {
+			/* MDL-Error indication (B) */
+
+			/* no state change */
+		} else {
+			/* MDL-Error indication (E) */
+
+			/* establish data link */
+			Q921EstablishDataLink(trunk, tei);
+
+			/* clear L3 initiated */
+			Q921_CLEAR_FLAG(trunk, Q921_FLAG_L3_INITIATED);
+
+			/* change state (no action?) */
+			Q921ChangeState(trunk, Q921_STATE_AWAITING_ESTABLISHMENT);
+		}
+		break;
+
+	case Q921_STATE_TIMER_RECOVERY:
+		if(pf) {
+			/* MDL Error indication (B) */
+		} else {
+			/* MDL Error indication (E) */
+		}
+
+		/* establish data link */
+		Q921EstablishDataLink(trunk, tei);
+
+		/* clear layer 3 initiated */
+		Q921_CLEAR_FLAG(trunk, Q921_FLAG_L3_INITIATED);
+
+		/* change state */
+		Q921ChangeState(trunk, Q921_STATE_AWAITING_ESTABLISHMENT);
+		break;
+
+	default:
+		break;
+	}
+
+	return 1;
+}
+
+/**
+ * Q921ProcUA
+ * \brief	Handle incoming UA
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	mes	pointer to message buffer
+ * \param[in]	size	size of message
+ * \return	> 0 on success, <= 0 on error
+ */
+int Q921ProcUA(L2TRUNK trunk, L2UCHAR *mes, L2INT size)
+{
+	L2UCHAR pf = (mes[2] & 0x10) >> 4;				/* poll / final flag */
+	L2UCHAR tei = (mes[1] & 0xfe) >> 1;
+	L2INT   idx = tei;
+
+	if(!Q921_IS_PTMP_NT(trunk))
+		idx = 0;
+
+	switch(trunk->state) {
+	case Q921_STATE_TEI_ASSIGNED:
+	case Q921_STATE_TIMER_RECOVERY:
+		/* MDL Error indication (C, D) */
+		Q921Log(trunk, Q921_LOG_ERROR, "Received UA frame in invalid state\n");
+		break;
+
+	case Q921_STATE_AWAITING_ESTABLISHMENT:
+		if(pf) {
+			/* TODO: other fancy stuff (see docs) */
+			if(Q921_CHECK_FLAG(trunk, Q921_FLAG_L3_INITIATED)) {	/* layer3 initiated */
+				trunk->vr[idx] = 0;
+
+				/* DL-Establish confirm */
+				Q921Tx23Proc(trunk, Q921_DL_ESTABLISH_CONFIRM, NULL, 0);
+
+			} else if(trunk->vs[idx] != trunk->va[idx]) {
+
+				/* discard I queue */
+				MFIFOClear(trunk->IFrameQueue);
+
+				/* DL-Establish indication */
+				Q921Tx23Proc(trunk, Q921_DL_ESTABLISH, NULL, 0);
+			}
+
+			/* Stop T200, start T203 */
+			Q921T200TimerStop(trunk, tei);
+			Q921T203TimerStart(trunk, tei);
+
+			trunk->vs[idx] = 0;
+			trunk->va[idx] = 0;
+
+			/* change state (no action) */
+			Q921ChangeState(trunk, Q921_STATE_MULTIPLE_FRAME_ESTABLISHED);
+		} else {
+			/* MDL Error indication (C, D) */
+			Q921Log(trunk, Q921_LOG_ERROR, "Received UA frame is not a response to a request\n");
+
+			/* no state change */
+		}
+		break;
+
+	case Q921_STATE_AWAITING_RELEASE:
+		if(pf) {
+			/* DL Release confirm */
+			Q921Tx23Proc(trunk, Q921_DL_RELEASE_CONFIRM, NULL, 0);
+
+			/* Stop T200 */
+			Q921T200TimerStop(trunk, tei);
+
+			/* change state (no action) */
+			Q921ChangeState(trunk, Q921_STATE_TEI_ASSIGNED);
+		} else {
+			/* MDL Error indication (D) */
+			Q921Log(trunk, Q921_LOG_ERROR, "Received UA frame is not a response to a request\n");
+
+			/* no state change */
+		}
+		break;
+
+	case Q921_STATE_MULTIPLE_FRAME_ESTABLISHED:
+		/* MDL Error indication (C, D) */
+		Q921Log(trunk, Q921_LOG_ERROR, "Received UA frame in invalid state\n");
+
+		/* no state change */
+		break;
+
+	default:
+		break;
+	}
+
+	return 1;
+}
+
+
+/**
+ * Q921ProcDISC
+ * \brief	Handle incoming DISC
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	mes	pointer to message buffer
+ * \param[in]	size	size of message
+ * \return	> 0 on success, <= 0 on error
+ */
+int Q921ProcDISC(L2TRUNK trunk, L2UCHAR *mes, L2INT size)
+{
+	L2UCHAR pf  = (mes[2] & 0x10) >> 4;				/* poll / final flag */
+	L2UCHAR tei = (mes[1] & 0xfe) >> 1;
+
+	switch(trunk->state) {
+	case Q921_STATE_TEI_ASSIGNED:
+	case Q921_STATE_AWAITING_ESTABLISHMENT:
+		/* Send DM */
+		Q921SendDM(trunk,
+				trunk->sapi,
+				Q921_RESPONSE(trunk),
+				tei, pf);
+
+		/* no state change */
+		break;
+
+	case Q921_STATE_AWAITING_RELEASE:
+		Q921SendUA(trunk,
+				trunk->sapi,
+				Q921_RESPONSE(trunk),
+				tei, pf);
+
+		/* no state change */
+		break;
+
+	case Q921_STATE_MULTIPLE_FRAME_ESTABLISHED:
+	case Q921_STATE_TIMER_RECOVERY:
+		/* Discard I queue */
+		MFIFOClear(trunk->IFrameQueue);
+
+		/* send UA */
+		Q921SendUA(trunk,
+				trunk->sapi,
+				Q921_RESPONSE(trunk),
+				tei, pf);
+		
+		/* DL Release indication */
+		Q921Tx23Proc(trunk, Q921_DL_RELEASE, NULL, 0);
+
+		/* Stop T200 */
+		Q921T200TimerStop(trunk, tei);
+
+		if(trunk->state == Q921_STATE_MULTIPLE_FRAME_ESTABLISHED) {
+			/* Stop T203 */
+			Q921T203TimerStop(trunk, tei);
+		}
+
+		/* change state (no action) */
+		Q921ChangeState(trunk, Q921_STATE_TEI_ASSIGNED);
+		break;
+
+	default:
+		Q921Log(trunk, Q921_LOG_ERROR, "Invalid DISC received in state \"%s\" (%d)", Q921State2Name(trunk->state), trunk->state);
+		break;
+	}
+
+	return 1;
+}
+
+
+/**
+ * Q921ProcRR
+ * \brief	Handle incoming RR
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	mes	pointer to message buffer
+ * \param[in]	size	size of message
+ * \return	> 0 on success, <= 0 on error
+ */
+int Q921ProcRR(L2TRUNK trunk, L2UCHAR *mes, L2INT size)
+{
+	L2UCHAR cr = (mes[0] & 0x02) >> 1;
+	L2UCHAR pf =  mes[3] & 0x01;		/* poll / final flag */
+	L2UCHAR nr = (mes[3] >> 1);
+//	L2UCHAR	sapi = (mes[0] & 0xfc) >> 2;
+	L2UCHAR	tei  = (mes[1] & 0xfe) >> 1;
+	L2INT idx = tei;
+
+	if(!Q921_IS_PTMP_NT(trunk))
+		idx = 0;
+
+	switch(trunk->state) {
+	case Q921_STATE_MULTIPLE_FRAME_ESTABLISHED:
+		/* clear receiver peer busy */
+		Q921_CLEAR_FLAG(trunk, Q921_FLAG_PEER_RECV_BUSY);
+
+		if (Q921_IS_COMMAND(trunk, cr)) { /* if this is a command */
+			if(pf) {
+				/* Enquiry response */
+				Q921SendEnquiryResponse(trunk, tei);
+			}
+		} else {
+			if(pf) {
+				/* MDL Error indication */
+			}
+		}
+
+		/* */
+		if(trunk->va[idx] <= nr && nr <= trunk->vs[idx]) {
+
+			if(nr == trunk->vs[idx]) {
+				/* V(A) = N(R) */
+				trunk->va[idx] = nr;
+
+				/* Stop T200, restart T203 */
+				Q921T200TimerStop(trunk, tei);
+				Q921T203TimerReset(trunk, tei);
+
+			} else if(nr == trunk->va[idx]) {
+
+				/* do nothing */
+
+			} else {
+				/* V(A) = N(R) */
+				trunk->va[idx] = nr;
+
+				/* Restart T200 */
+				Q921T200TimerReset(trunk, tei);
+			}
+			/* no state change */
+
+		} else {
+			/* N(R) Error recovery */
+			Q921NrErrorRecovery(trunk, tei);
+
+			/* change state (no action) */
+			Q921ChangeState(trunk, Q921_STATE_AWAITING_ESTABLISHMENT);
+		}
+		break;
+
+	case Q921_STATE_TIMER_RECOVERY:
+		/* clear receiver peer busy */
+		Q921_CLEAR_FLAG(trunk, Q921_FLAG_PEER_RECV_BUSY);
+
+		/* command + P? */
+		if(Q921_IS_COMMAND(trunk, cr) && pf) {
+			/* Enquiry response */
+			Q921SendEnquiryResponse(trunk, tei);
+		}
+
+		/* */
+		if(trunk->va[idx] <= nr && nr <= trunk->vs[idx]) {
+			/* V(A) = N(R) */
+			trunk->va[idx] = nr;
+
+			if(!Q921_IS_COMMAND(trunk, cr) && pf) {
+				/* Stop T200, start T203 */
+				Q921T200TimerStop(trunk, tei);
+				Q921T203TimerStart(trunk, tei);
+
+				/* Invoke retransmission */
+
+				/* change state (no action) */
+				Q921ChangeState(trunk, Q921_STATE_MULTIPLE_FRAME_ESTABLISHED);
+			}
+			/* no state change otherwise */
+		} else {
+			/* N(R) Error recovery */
+			Q921NrErrorRecovery(trunk, tei);
 
+			/* change state (no action) */
+			Q921ChangeState(trunk, Q921_STATE_AWAITING_ESTABLISHMENT);
+		}
+		break;
+
+	default:
+		break;
+	}
     return 1;
 }
 
+
+/**
+ * Q921ProcREJ
+ * \brief	Handle incoming REJ
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	mes	pointer to message buffer
+ * \param[in]	size	size of message
+ * \return	> 0 on success, <= 0 on error
+ */
+int Q921ProcREJ(L2TRUNK trunk, L2UCHAR *mes, L2INT size)
+{
+	L2UCHAR cr = (mes[0] & 0x02) >> 1;
+	L2UCHAR pf =  mes[3] & 0x01;		/* poll / final flag */
+	L2UCHAR nr = (mes[3] >> 1);
+//	L2UCHAR	sapi = (mes[0] & 0xfc) >> 2;
+	L2UCHAR	tei  = (mes[1] & 0xfe) >> 1;
+	L2INT idx = tei;
+
+	if(!Q921_IS_PTMP_NT(trunk))
+		idx = 0;
+
+	switch(trunk->state) {
+	case Q921_STATE_MULTIPLE_FRAME_ESTABLISHED:
+		/* clear receiver peer busy */
+		Q921_CLEAR_FLAG(trunk, Q921_FLAG_PEER_RECV_BUSY);
+
+		/* command? */
+		if(Q921_IS_COMMAND(trunk, cr)) {
+			if(pf) {
+				/* Enquiry response */
+				Q921SendEnquiryResponse(trunk, tei);
+			}
+		} else {
+			if(pf) {
+				/* MDL Error indication (A) */
+			}
+		}
+
+		/* */
+		if(trunk->va[idx] <= nr && nr <= trunk->vs[idx]) {
+
+			/* V(A) = N(R) */
+			trunk->va[idx] = nr;
+
+			/* Stop T200, start T203 */
+			Q921T200TimerStop(trunk, tei);
+			Q921T203TimerStart(trunk, tei);
+
+			/* Invoke retransmission of frame >N(R)  (?) */
+
+			/* no state change */
+		} else {
+			/* N(R) Error recovery */
+			Q921NrErrorRecovery(trunk, tei);
+
+			/* change state (no action) */
+			Q921ChangeState(trunk, Q921_STATE_AWAITING_ESTABLISHMENT);
+		}
+		break;
+
+	case Q921_STATE_TIMER_RECOVERY:
+		/* clear receiver peer busy */
+		Q921_CLEAR_FLAG(trunk, Q921_FLAG_PEER_RECV_BUSY);
+
+		/* command + P ? */
+		if(Q921_IS_COMMAND(trunk, cr) && pf) {
+			/* Enquiry response */
+			Q921SendEnquiryResponse(trunk, tei);
+		}
+
+		/* */
+		if(trunk->va[idx] <= nr && nr <= trunk->vs[idx]) {
+
+			/* V(A) = N(R) */
+			trunk->va[idx] = nr;
+
+			if(!Q921_IS_COMMAND(trunk, cr) && pf) {
+				/* Stop T200, start T203 */
+				Q921T200TimerStop(trunk, tei);
+				Q921T203TimerStart(trunk, tei);
+
+				/* Invoke retransmission */
+
+				/* change state (no action) */
+				Q921ChangeState(trunk, Q921_STATE_MULTIPLE_FRAME_ESTABLISHED);
+			}
+			/* no state change otherwise */
+		} else {
+			/* N(R) Error recovery */
+			Q921NrErrorRecovery(trunk, tei);
+
+			/* change state (no action) */
+			Q921ChangeState(trunk, Q921_STATE_AWAITING_ESTABLISHMENT);
+		}
+		break;
+
+	default:
+		break;
+	}
+
+	return 1;
+}
+
+
+/**
+ * Q921ProcRNR
+ * \brief	Handle incoming RNR
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	mes	pointer to message buffer
+ * \param[in]	size	size of message
+ * \return	> 0 on success, <= 0 on error
+ */
+int Q921ProcRNR(L2TRUNK trunk, L2UCHAR *mes, L2INT size)
+{
+	L2UCHAR cr = (mes[0] & 0x02) >> 1;
+	L2UCHAR pf =  mes[3] & 0x01;		/* poll / final flag */
+	L2UCHAR nr = (mes[3] >> 1);
+//	L2UCHAR	sapi = (mes[0] & 0xfc) >> 2;
+	L2UCHAR	tei  = (mes[1] & 0xfe) >> 1;
+	L2INT idx = tei;
+
+ 	if(!Q921_IS_PTMP_NT(trunk))
+		idx = 0;
+
+	switch(trunk->state) {
+	case Q921_STATE_MULTIPLE_FRAME_ESTABLISHED:
+		/* set peer receiver busy */
+		Q921_SET_FLAG(trunk, Q921_FLAG_PEER_RECV_BUSY);
+
+		/* command? */
+		if(Q921_IS_COMMAND(trunk, cr)) {
+			if(pf) {
+				/* Enquiry response */
+				Q921SendEnquiryResponse(trunk, tei);
+			}
+		} else {
+			if(pf) {
+				/* MDL Error indication (A) */
+			}
+		}
+
+		/* */
+		if(trunk->va[idx] <= nr && nr <= trunk->vs[idx]) {
+
+			/* V(A) = N(R) */
+			trunk->va[idx] = nr;
+
+			/* Stop T203, restart T200 */
+			Q921T200TimerReset(trunk, tei);
+			Q921T203TimerStop(trunk, tei);
+
+			/* no state change */
+		} else {
+			/* N(R) Error recovery */
+			Q921NrErrorRecovery(trunk, tei);
+
+			/* change state (no action) */
+			Q921ChangeState(trunk, Q921_STATE_AWAITING_ESTABLISHMENT);
+		}
+		break;
+
+	case Q921_STATE_TIMER_RECOVERY:
+		/* set peer receiver busy */
+		Q921_SET_FLAG(trunk, Q921_FLAG_PEER_RECV_BUSY);
+
+		/* command + P? */
+		if(Q921_IS_COMMAND(trunk, cr) && pf) {
+			/* Enquiry response */
+			Q921SendEnquiryResponse(trunk, tei);
+		}
+
+		/* */
+		if(trunk->va[idx] <= nr && nr <= trunk->vs[idx]) {
+
+			/* V(A) = N(R) */
+			trunk->va[idx] = nr;
+
+			if(!Q921_IS_COMMAND(trunk, cr) && pf) {
+				/* Restart T200 */
+				Q921T200TimerReset(trunk, tei);
+
+				/* Invoke retransmission */
+
+				/* change state (no action) */
+				Q921ChangeState(trunk, Q921_STATE_MULTIPLE_FRAME_ESTABLISHED);
+			}
+			/* no state change otherwise */
+		} else {
+			/* N(R) Error recovery */
+			Q921NrErrorRecovery(trunk, tei);
+
+			/* change state (no action) */
+			Q921ChangeState(trunk, Q921_STATE_AWAITING_ESTABLISHMENT);
+		}
+		break;
+
+	default:
+		break;
+	}
+
+	return 1;
+}
+
+int Q921SetReceiverBusy(L2TRUNK trunk) {
+
+	switch(trunk->state) {
+	case Q921_STATE_MULTIPLE_FRAME_ESTABLISHED:
+		if(!Q921_CHECK_FLAG(trunk, Q921_FLAG_RECV_BUSY)) {
+			/* set own receiver busy */
+			Q921_SET_FLAG(trunk, Q921_FLAG_RECV_BUSY);
+
+			/* send RR response */
+			Q921SendRR(trunk, trunk->sapi, Q921_RESPONSE(trunk), trunk->tei, 0);
+
+			/* clear ack pending */
+			Q921_CLEAR_FLAG(trunk, Q921_FLAG_ACK_PENDING);
+		}
+		break;
+
+	case Q921_STATE_TIMER_RECOVERY:
+		if(!Q921_CHECK_FLAG(trunk, Q921_FLAG_RECV_BUSY)) {
+			/* set own receiver busy */
+			Q921_SET_FLAG(trunk, Q921_FLAG_RECV_BUSY);
+
+			/* send RNR response */
+			Q921SendRNR(trunk, trunk->sapi, Q921_RESPONSE(trunk), trunk->tei, 0);
+
+			/* clear ack pending */
+			Q921_CLEAR_FLAG(trunk, Q921_FLAG_ACK_PENDING);
+		}
+		break;
+
+	default:
+		break;
+	}
+
+	return 0;
+}
+
+int Q921ClearReceiverBusy(L2TRUNK trunk) {
+
+	switch(trunk->state) {
+	case Q921_STATE_MULTIPLE_FRAME_ESTABLISHED:
+	case Q921_STATE_TIMER_RECOVERY:
+		if(Q921_CHECK_FLAG(trunk, Q921_FLAG_RECV_BUSY)) {
+			/* clear own receiver busy */
+			Q921_CLEAR_FLAG(trunk, Q921_FLAG_RECV_BUSY);
+
+			/* send RNR response */
+			Q921SendRNR(trunk, trunk->sapi, Q921_RESPONSE(trunk), trunk->tei, 0);
+
+			/* clear ack pending */
+			Q921_CLEAR_FLAG(trunk, Q921_FLAG_ACK_PENDING);
+		}
+		break;
+
+	default:
+		break;
+	}
+
+	return 0;
+}
+
+int Q921ProcIFrame(L2TRUNK trunk, L2UCHAR *mes, L2INT size)
+{
+	/* common fields: get sapi, tei and cr */
+//	L2UCHAR sapi = (mes[0] & 0xfc) >> 2;
+//	L2UCHAR cr   = (mes[0] & 0x02) >> 1;
+	L2UCHAR tei  = (mes[1] & 0xfe) >> 1;
+	L2UCHAR pf   =  mes[3] & 0x01;		/* poll / final flag */
+	L2UCHAR nr   =  mes[3] >> 1;		/* receive sequence number */
+	L2UCHAR ns   =  mes[2] >> 1;		/* send sequence number */
+	L2UCHAR discard = 0;
+	L2INT idx = tei;
+
+	if(!Q921_IS_PTMP_NT(trunk))
+		idx = 0;
+
+	/* Ignore I frames in earlier states */
+	if(trunk->state < Q921_STATE_MULTIPLE_FRAME_ESTABLISHED) {
+		Q921Log(trunk, Q921_LOG_NOTICE, "I fFrame in invalid state ignored\n");
+		return 0;
+	}
+
+	/* Receiver busy? */
+	if(Q921_CHECK_FLAG(trunk, Q921_FLAG_RECV_BUSY)) {
+		/* discard information */
+		discard = 1;
+
+		if(pf) {
+			/* send RNR Response */
+			Q921SendRNR(trunk, trunk->sapi, Q921_RESPONSE(trunk), tei, 1);
+
+			/* Clear ack pending */
+			Q921_CLEAR_FLAG(trunk, Q921_FLAG_ACK_PENDING);
+		}
+	}
+	else {
+		if(ns != trunk->vr[idx]) {
+			/* discard information */
+			discard = 1;
+
+			if(Q921_CHECK_FLAG(trunk, Q921_FLAG_REJECT) && pf) {
+
+				/* Send RR response */
+				Q921SendRR(trunk, trunk->sapi, Q921_RESPONSE(trunk), tei, 1);
+
+				/* clear ack pending */
+				Q921_CLEAR_FLAG(trunk, Q921_FLAG_ACK_PENDING);
+			}
+			else if(!Q921_CHECK_FLAG(trunk, Q921_FLAG_REJECT)){
+
+				/* set reject exception */
+				Q921_SET_FLAG(trunk, Q921_FLAG_REJECT);
+
+				/* Send REJ response */
+				Q921SendREJ(trunk, trunk->sapi, Q921_RESPONSE(trunk), tei, pf);
+
+				/* clear ack pending */
+				Q921_CLEAR_FLAG(trunk, Q921_FLAG_ACK_PENDING);
+			}
+		}
+		else {
+			/* V(R) = V(R) + 1 */
+			Q921_INC_COUNTER(trunk->vr[idx]);
+
+			/* clear reject exception */
+			Q921_CLEAR_FLAG(trunk, Q921_FLAG_REJECT);
+
+			/* DL-Data indication */
+			Q921Tx23Proc(trunk, Q921_DL_DATA, mes, size);
+
+			if(pf) {
+				/* Send RR response */
+				Q921SendRR(trunk, trunk->sapi, Q921_RESPONSE(trunk), tei, 1);
+
+				/* clear ack pending */
+				Q921_CLEAR_FLAG(trunk, Q921_FLAG_ACK_PENDING);
+			}
+			else if(!Q921_CHECK_FLAG(trunk, Q921_FLAG_ACK_PENDING)) {
+				/* ack pending */
+
+				/* Send RR response */
+				Q921SendRR(trunk, trunk->sapi, Q921_RESPONSE(trunk), tei, 0);
+				
+				/* set ack pending*/
+				Q921_SET_FLAG(trunk, Q921_FLAG_ACK_PENDING);
+			}
+		}
+	}
+
+
+	switch(trunk->state) {
+	case Q921_STATE_MULTIPLE_FRAME_ESTABLISHED:
+		if(trunk->va[idx] <= nr && nr <= trunk->vs[idx]) {
+			if(Q921_CHECK_FLAG(trunk, Q921_FLAG_PEER_RECV_BUSY)) {
+				trunk->va[idx] = nr;
+			}
+			else if(nr == trunk->vs[idx]) {
+				/* V(A) = N(R) */
+				trunk->va[idx] = nr;
+
+				/* stop t200, restart t203 */
+				Q921T200TimerStop(trunk, tei);
+				Q921T203TimerReset(trunk, tei);
+			}
+			else if(nr != trunk->va[idx]) {
+				/* V(A) = N(R) */
+				trunk->va[idx] = nr;
+
+				/* restart T200 */
+				Q921T200TimerReset(trunk, tei);
+			}
+		}
+		else {
+			/* N(R) error recovery */
+			Q921NrErrorRecovery(trunk, tei);
+
+			/* change state (no action) */
+			Q921ChangeState(trunk, Q921_STATE_AWAITING_ESTABLISHMENT);
+		}
+		break;
+
+	case Q921_STATE_TIMER_RECOVERY:
+		if(trunk->va[idx] <= nr && nr <= trunk->vs[idx]) {
+			/* V(A) = N(R) */
+			trunk->va[idx] = nr;
+		}
+		else {
+			/* N(R) error recovery */
+			Q921NrErrorRecovery(trunk, tei);
+
+			/* change state (no action) */
+			Q921ChangeState(trunk, Q921_STATE_AWAITING_ESTABLISHMENT);
+		}
+		break;
+
+	default:
+		break;
+	}
+
+	return 0;
+}
+
+
+int Q921ProcSFrame(L2TRUNK trunk, L2UCHAR *mes, L2INT size)
+{
+	L2UCHAR sv = (mes[2] & 0x0c) >> 2;	/* supervisory format id */
+	//L2UCHAR pf = mes[3] & 0x01;		/* poll / final flag */
+	//L2UCHAR nr = mes[3] >> 1;		/* receive sequence number */
+	L2INT res = -1;
+
+	switch(sv) {
+	case 0x00:	/* RR : Receive Ready */
+		res = Q921ProcRR(trunk, mes, size);
+		break;
+
+	case 0x02:	/* RNR : Receive Not Ready */
+		res = Q921ProcRNR(trunk, mes, size);
+		break;
+
+	case 0x04:	/* REJ : Reject */
+		res = Q921ProcREJ(trunk, mes, size);
+		break;
+
+	default:	/* Invalid / Unknown */
+		Q921Log(trunk, Q921_LOG_ERROR, "Invalid S frame type %d\n", sv);
+		break;
+	}
+
+	return res;
+}
+
+
+
+int Q921ProcUFrame(L2TRUNK trunk, L2UCHAR *mes, L2INT size) 
+{
+	L2UCHAR m  = (mes[2] & 0xe0) >> 3 | (mes[2] & 0x0c) >> 2;	/* modifier function id */
+//	L2UCHAR pf = (mes[2] & 0x10) >> 4;				/* poll / final flag */
+	L2INT res = -1;
+
+	switch(m) {
+	case 0x00:	/* UN : Unnumbered Information */
+		if(mes[3] == Q921_LAYER_ENT_ID_TEI)
+		{
+			if(!Q921_IS_PTMP(trunk)) {
+				/* wtf? nice try */
+				return res;
+			}
+
+			switch(mes[6]) {
+			case Q921_TEI_ID_REQUEST:	/* (TE ->) NT */
+				res = Q921TeiProcAssignRequest(trunk, mes, size);
+				break;
+
+			case Q921_TEI_ID_ASSIGNED:	/* (NT ->) TE */
+			case Q921_TEI_ID_DENIED:
+				res = Q921TeiProcAssignResponse(trunk, mes, size);
+				break;
+
+			case Q921_TEI_ID_CHECKREQ:	/* (NT ->) TE */
+				res = Q921TeiProcCheckRequest(trunk, mes, size);
+				break;
+
+			case Q921_TEI_ID_CHECKRESP:	/* (TE ->) NT */
+				res = Q921TeiProcCheckResponse(trunk, mes, size);
+				break;
+
+			case Q921_TEI_ID_REMOVE:	/* (NT ->) TE */
+				res = Q921TeiProcRemoveRequest(trunk, mes, size);
+				break;
+
+			case Q921_TEI_ID_VERIFY:	/* (TE ->) NT */
+				res = Q921TeiProcVerifyRequest(trunk, mes, size);
+				break;
+
+			default:			/* Invalid / Unknown */
+				Q921Log(trunk, Q921_LOG_ERROR, "Invalid UN message from TEI management/endpoint\n");
+				break;
+			}
+		}
+		else if(mes[3] == Q921_LAYER_ENT_ID_Q931) {
+
+			Q921Log(trunk, Q921_LOG_DEBUG, "UI Frame for Layer 3 received\n");
+
+			res = Q921Tx23Proc(trunk, Q921_DL_UNIT_DATA, mes, size);
+		}
+		break;
+
+	case 0x03:	/* DM : Disconnect Mode */
+		res = Q921ProcDM(trunk, mes, size);
+		break;
+
+	case 0x08:	/* DISC : Disconnect */
+		res = Q921ProcDISC(trunk, mes, size);
+		break;
+
+	case 0x0c:	/* UA : Unnumbered Acknowledgement */
+		res = Q921ProcUA(trunk, mes, size);
+		break;
+
+	case 0x0f:	/* SABME  : Set Asynchronous Balanced Mode Extend */
+		res = Q921ProcSABME(trunk, mes, size);
+		break;
+
+	case 0x11:	/* FRMR : Frame Reject */
+	case 0x17:	/* XID : Exchange Identification */
+		res = 0;
+		break;
+
+	default:	/* Unknown / Invalid */
+		Q921Log(trunk, Q921_LOG_ERROR, "Invalid U frame type: %d\n", m);
+		break;
+	}
+
+	return res;
+}
+
+
 /*****************************************************************************
 
   Function:     Q921Rx12
